<?php
/*
	Plugin Name: 	ChibiPaint for Wordpress
	Plugin URI: 	http://antimatter-charge.com/projects/chibipaint/
	Version: 		0.2b
	Author: 		Mifuyne
	Description: 	Integrates the Java applet "Chibipaint" <http://www.chibipaint.com/> with wordpress so drawings can be made and saved to the server. The plan is to keep all saves inside the upload folder under its own. This plugin was modelled after the Wordpress Shi-Painter Plugin (http://blog.yakumo.la/?page_id=13).
	
	Copyright 2010 Mifuyne (email: mifuyne [at] gmail [dot] com)
	
	This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

	Note: Please refer to the readme.txt file for documentation.
*/

if (is_admin()) {
	function cbp_init() {
		add_action('media_upload_tabs', 'add_media_upload_cbp');	// Add a tab to the media upload in Post Add/Edit
		add_action('media_upload_cbp', 'media_upload_cbp');			// Add content for said tab (it's its own hook...)
		add_action('admin_menu', 'cbp_admin_menu');					// Add an admin menu based on cbp_admin_menu function
		// Options
		$upgrade_cbp	= get_option('cbp');
		if (!isset($upgrade_cbp['version']) || "0.2b" == $upgrade_cbp['version'] || !isset($upgrade_cbp['access']))
			delete_option( 'cbp' );		// active on activation
		add_option( 'cbp', cbp_settings() );						// Add settings based on cbp_settings function		
	}

	function cbp_settings() {	// Adding setting via array...
		$options = array(
			'version'		=> '0.2b',
			'def_Width'		=> 383,		// Default Width...it was a random number
			'def_Height'	=> 475,		// Default Height...
			'pre_Sizes'		=> array('', 			// Preset Sizes...
									'320x240', 
									'640x480', 
									'800x600', 
									'200x200', 
									'400x400', ),
			'templates'		=> array('specify', ''),	// Preset Templates
			'access'		=> '2'
			);
		return $options;

	}
	function cbp_admin_menu() {
		$cbpSet		= get_option ('cbp');
		$cbp_access = $cbpSet['access'];	
		if(function_exists('add_menu_page')) {
			add_menu_page('ChibiPaint', 'ChibiPaint', $cbp_access, basename(__FILE__), 'cbp_optionsPage');
		}
		if(function_exists('add_submenu_page')) {
			add_submenu_page('chibipaint.php', 'ChibiPaint &mdash; Options', 'Options', $cbp_access, basename(__FILE__), 'cbp_optionsPage'); 
			add_submenu_page('chibipaint.php', 'ChibiPaint &mdash; Manager', 'Manager', $cbp_access, 'cbp-manage', 'cbp_manager'); 
		}
	}

	require_once(dirname(__FILE__).'/inc/cbp-media.php');

	// CBP Manager
	require_once(dirname(__FILE__).'/inc/cbp-manager.php');

	// CBP Options
	require_once(dirname(__FILE__).'/inc/cbp-options.php');

	// End Editing Block
	cbp_init();
}
?>
