<?php
// ChibiPaint media tab
$cbpSet		= get_option ('cbp');
$cbp_access = $cbpSet['access'];	
function add_media_upload_cbp($tabs) {	// Add Chibipaint to the row of tabs...
	global $cbp_access;
	if ( current_user_can('level_'.$cbp_access)) {
		if((array_key_exists('type', $_POST) && $_POST['type'] == 'image') || (array_key_exists('type', $_GET) && $_GET['type'] == 'image')){
			$tabs = array_merge($tabs, array('cbp' => __('ChibiPaint')));
		}
		return $tabs;
	}
	else {
		if((array_key_exists('type', $_POST) && $_POST['type'] == 'image') || (array_key_exists('type', $_GET) && $_GET['type'] == 'image')){
			return $tabs;
		}
	}
}

function media_upload_cbp() {	// The content in the tab
	
	// Checking for errors...
	if(!empty($_GET['cbp_stat']) && 'sent' == $_GET['cbp_stat']){
		return '';
	}
	else if(!empty($_POST['cbp_stat'])){
		return wp_iframe('media_upload_cbp_form', $errors);	// Show this form if $_POST['cbp_stat'] has data...this is necessary for the form submission to work
	}
	else if(!empty($_POST)){
		$return = media_upload_form_handler(); 
		if(is_string($return)){
			return $return;
		}
		if(is_array($return)){
			$errors = $return;	// There are errors...
		}
	}
	  return wp_iframe( 'media_upload_cbp_form', $errors );	// Show this form if the above conditionals aren't satisfied
}

function media_upload_cbp_form() {	// Canvas Settings Form or the Canvas?
	media_upload_header();			// It's needed for the tab bar
	$dataSent = FALSE;				// No data is sent, this is necessary because $_POST data doesn't cross functions
	if (!empty($_POST['cbp_stat'])) {
		if ('sent' == $_POST['cbp_stat']) {
			$dataSent = TRUE;
			cbp_painterCanvas();	// Show the canvas if the form has been sent
		}
	}
	if (!$dataSent) {
		cbp_painterCanvasSettingsForm(); // Show the canvas settings form if the visitor just got here.
	}
}

// New Painting Block
function cbp_painterCanvas() {	// Gathering info for the canvas and the canvas itself...
	check_admin_referer('cbp-nonce-settings-form');
	if (!empty($_POST['size'])) {	// This will determine if the size of the canvas is manually entered or by the presets...this is the preset condition
		$canSize 	= explode('x', $_POST['size']);	// split the line, divided by the x...which means all new presets must follow the format set
		$canWidth	= $canSize[0];	// the width
		$canHeight	= $canSize[1];	// the height
	}
	else {
		$canWidth	= $_POST['can_w'];	// manual Width
		$canHeight	= $_POST['can_h'];	// manual Height
	}
	if ($_POST['template'] == "specify") {
		$tempName	= $_POST['temp_name'];	// if the preset template is set to specify, then it will pull the template info from the textbox
	}
	else {
		$tempName	= $_POST['template'];	// Pulled from preset template
	}
	$cbp_img = array(
		'canW'		=> $canWidth,	// The canvas width
		'canH'		=> $canHeight,	// The canvas height
		'postURL'	=> WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)) . 'cbp-save.php',	// the script that saves the data into png and chi file
		'exitURL'	=> get_option('siteurl') . "/wp-admin/media-upload.php?post_id=$post_id&type={$GLOBALS['type']}&tab=library",	// Where the applet sends the user to when the data was successfully saved
		'template'	=> $tempName,	// the address of the template, if available
		'fTarget'	=> $_POST['frame_id'],	// Where is the exit URL opened in (keeps it in the same popup)
		'post_id'	=> intval($_REQUEST['post_id']),	// Creates a temporary post_id
	);
	// Strip the address to determine its extension...
	$pngChiExt	= (strpos($cbp_img['template'], '.') === FALSE) ? '' : substr($cbp_img['template'], strrpos($cbp_img['template'], '.'));
	?>
<script type="text/javascript">
<!--
jQuery(function($){
	var preloaded = $(".media-item.preloaded");
	if ( preloaded.length > 0 ) {
		preloaded.each(function(){prepareMediaItem({id:this.id.replace(/[^0-9]/g, '')},'');});
		updateMediaForm();
	}
});
-->
</script>
	
<?php
// Calls to the function and creates an instance of it for creating a new painting
cbp_canvasTemplate($cbp_img['postURL'], $cbp_img['exitURL'], $cbp_img['fTarget'], $cbp_img['template'], $canWidth, $canHeight, $pngChiExt); 
}

// In an attempt to cut down on line count...the applet has been modularized, the variables are pretty self-explanatory
require_once(dirname(__FILE__).'/cbp-canvas.php');

function cbp_painterCanvasSettingsForm() {	// Step 2-1: If no data has been sent, then display canvas settings form
	$post_id = intval($_REQUEST['post_id']);	// Request current post's ID
	$cbp_nonce_set_form	= wp_create_nonce  ('cbp-nonce-settings-form');	
	$actionURL = get_option('siteurl') . "/wp-admin/media-upload.php?post_id=$post_id&type={$GLOBALS['type']}&tab=cbp";	// form action's current url
	$cbpSet = get_option( 'cbp' ); // Grab the options
	// -- HTML -- ?>
	<!-- Canvas Settings Form -->
	<form method="post" action="<?php echo esc_attr($actionURL); ?>">
		<?php wp_nonce_field('cbp-nonce-settings-form'); ?>

		<div id="canvas-form">
			<div class="describe">
				<h3><?php echo _e("Canvas Settings"); ?></h3>
				<h5>Canvas Size (blank canvas)</h5>
				<p><label for="can_w"><?php echo _e("Width"); ?></label>
				<span><input type="text" name="can_w" size="10" value="<?php echo $cbpSet['def_Width']; ?>" style="display: inline; width: 150px;" autocomplete="off" /></span> x <label for="can_h"><?php echo _e("Height"); ?></label>
				<span><input type="text" name="can_h" size="10" value="<?php echo $cbpSet['def_Height']; ?>" style="display: inline; width: 150px;" autocomplete="off" /></span></p>
				<p><label for="size"><?php echo _e("Preset Sizes"); ?></label>
				<select name="size">
<?php foreach ($cbpSet['pre_Sizes'] as $sizes) { ?>
					<option value="<?php echo $sizes; ?>"><?php echo $sizes; ?></option>
<?php } ?>
				</select></p>
				<h5>Template (any info here will ignore the sizes you set in the above fields)</h5>
				<p><label for="temp_name"><?php echo _e("Template URL"); ?></label>
				<span><input type="text" name="temp_name" size="10" maxlength="128" value="" style="display: inline; width: 250px;" autocomplete="off" /></span>
				<p><label for="template"><?php echo _e("Preset Templates"); ?></label>
				<span><select name="template">
<?php foreach ($cbpSet['templates'] as $templates) { ?>
				<option value="<?php echo $templates; ?>"><?php echo $templates; ?></option>
<?php } ?>
				</select></span></p>
				</p>
			</div>
		</div>
		<p class="submit">
			<input type="submit" name="submit" value="<?php _e('Set Settings'); ?>" />
		</p>
		<input type="hidden" name="cbp_stat" value="sent" />
		<input type="hidden" name="post_id" id="post_id" value="<?php echo $post_id; ?>" />
		<input type="hidden" name="type" value="<?php echo $GLOBALS['type']; ?>" />
		<input type="hidden" name="tab" value="<?php echo $GLOBALS['tab']; ?>" />
		<script type="text/javascript">
		<!--
		document.write('<input type="hidden" name="frame_id" value="');
		document.write(top.document.getElementById('TB_iframeContent').name);
		document.write('" />');
		// -->
		</script>
	</form>
	<!-- / Canvas Settings Form -->	
<?php
}
?>
